#!/bin/sh 

exec_option=$1

if [ -f /persistent/etc/network.conf ]
then
	. /persistent/etc/network.conf
	echo $TIMEZONE > /etc/TZ
	if [ $exec_option == start ]
	then
		echo $HOSTNAME > /etc/HOSTNAME
		hostname -F /etc/HOSTNAME
		echo "127.0.0.1  $DOMAIN  localhost" > /etc/hosts
		echo "127.0.0.1  $HOSTNAME" >> /etc/hosts
		if [ "$DHCPD" == yes ]
		then
			rm -f /var/run/dhcpcd*
			dhcpcd &
		else
			ifconfig $IF down

			ifconfig $IF $IPADDRESS netmask $NETMASK up
			route add default gw $GATEWAY
			if [ ! -f /etc/resolv.conf ]
			then
				touch /etc/resolv.conf
			fi
			echo "nameserver  $DNS1" > /etc/resolv.conf
			echo "nameserver  $DNS2" >> /etc/resolv.conf
			ifconfig $IF:2 $IPADDRESS2 netmask $NETMASK2 up
		fi
	elif [ $exec_option == stop ]
	then
		killall -9 dhcpcd
		rm -f /var/run/dhcpcd*
		ifconfig $IF down
	fi
	ZONE=`echo $TIMEZONE | awk -F, '{print $1}'`
	if [ -f /etc/localtime ]
        rm /etc/localtime
	fi
	ln -s /usr/share/zoneinfo/$ZONE /etc/localtime
else
	if [ -f /etc/.rootfs_copied ]
	then
		ifconfig eth0 192.168.5.66 up
		route add default gw 192.168.5.1
		echo "nameserver  192.168.5.1" > /etc/resolv.conf
		sleep 5
	fi
fi
