
function Rule(pri, act, name, des, protocol, ip, mac, port){
	this.pri         = pri;         //priority
	this.act         = act;         //action
	this.name        = name;        //name
	this.des         = des;         //description
	this.protocol    = protocol;    //protocol
	this.ip          = ip;          //ip address
	this.mac         = mac;         //mac address
	this.port        = port;        //port
}

function Defence(pri, port, protocol, count, interval, type){
	this.pri         = pri;
	this.port        = port;
	this.protocol    = protocol;
	this.count       = count;
	this.interval    = interval;
	this.type        = type;      //0 - auto defence;  1 - sip defence
}

function Settings(enable, ping, drop, status, ssh, http, cgi, sip){
	this.enable      = enable;      //enable firewall, default is no
	this.disableping = ping;        //disable ping, default is no
	this.dropunmatch = drop;        //drop unmatch, default is no
	this.status      = status;      //firewall status, 0 means succefull, other means startup failed
	this.sshport     = ssh;
	this.httpport    = http;
	this.cgiport     = cgi;
	this.sipport     = sip;
	this.rules       = [];          //the array of rule
	this.defence     = [];          //the array of auto defence rule
}

function SortRule(r1, r2){
	return r1.pri-r2.pri;
}

function IsValidMac(s){
	var rMac=/^([0-9a-fA-F]{2})(([:][0-9a-fA-F]{2}){5})$/; 
	if(!rMac.test(s)){ 
		return false; 
	} 
	return true;
}

var FirewallObj = {
	aRuleHeader: ["", SG_FIREWALL_RULEACTION, SG_FIREWALL_RULENAME, SG_FIREWALL_RULEPROTOCOL, SG_FIREWALL_RULEIP, SG_FIREWALL_RULEMAC, SG_FIREWALL_RULEPORT, ""],
	aDefenceHeader: [SG_FIREWALL_DEFENCEPORT, SG_FIREWALL_DEFENCEPROTOCOL, SG_FIREWALL_DEFENCERATE, ""],
	aSipDefenceHeader: [SG_FIREWALL_SIPCOUNT, SG_FIREWALL_SIPINTERVAL, ""],
	oSettings: new Settings(false, false, false, false, -1),
	bRuleEdit: false,
	bDefenceEdit: false,
	bSipDefenceEdit: false,
	
	
	ConfirmDelete: function(fConfirm, sId, sDel, bCheck){
		if(confirm(fConfirm+"-"+sId)){
			if(bCheck && this.CheckAllRules(sId) == false 
			&& this.oSettings.dropunmatch){
				var s = SG_FIREWALL_NOTDELETE;
				s = s.replace("%p1", this.oSettings.sshport);
				s = s.replace("%p2", this.oSettings.httpport);
				s = s.replace("%p3", this.oSettings.cgiport);
				alert(s);
				return;
			}
			else{
				window.location.href = sDel;
			}
		}
	},
	
	MakeDefenceInterval: function(s){
		if(s == "1"){
			return "sec";
		}
		else if(s == "60"){
			return "min";
		}
		else if(s == "3600"){
			return "hour";			
		}
	},
	
	AddFirewallOption: function(nEdit, nDel, sValue, fConfirm, sItem, bCheck){ 
		var sEdit = "";
		var sDel = "";
		var sReturn = "";
		var msgEdit =readyto+" "+Edit+" ...";
		var msgDel = Delete + " " +success;
		if (nEdit > 0) {
			sEdit = "window.location.href=\"" + make_request_url_firewall(G_SERVER_URL, nEdit, sValue) + "\";";
			sReturn += "<span class='guiButtonModify' onclick='" + sEdit + "'>" + Edit + "</span>&nbsp;";
		}
		if (nDel > 0) {
			sReturn += "<span class='guiButtonDelete' onclick='FirewallObj.ConfirmDelete(\"" + fConfirm + "\",\"" + sItem + "\",\"" + make_request_url_firewall(G_SERVER_URL, nDel, sValue) + "\"," + bCheck +");' >" + Delete + "</span>";
		}
		return sReturn;
	},
	
	/* ---- Add arrow for adjusting the priority dynamicly for the rules ---- */
	AddArrow: function(n, pri){
		var sReturn = "";
		var d = "window.location.href=\"" + make_request_url_firewall(G_SERVER_URL, 2010, pri) + "\";";
		var b = "window.location.href=\"" + make_request_url_firewall(G_SERVER_URL, 2012, pri) + "\";";
		var u = "window.location.href=\"" + make_request_url_firewall(G_SERVER_URL, 2009, pri) + "\";";
		var t = "window.location.href=\"" + make_request_url_firewall(G_SERVER_URL, 2011, pri) + "\";";
		switch(n){
			case "first":
				sReturn += "<img style='cursor:hand;' src='../images/move_down.gif' onclick='" + d + "' />";
				sReturn += "&nbsp;&nbsp;<img style='cursor:hand;' src='../images/move_bottom.png' onclick='" + b + "' />";
				break;
			case "middle":
				sReturn += "<img style='cursor:hand;' src='../images/move_top.png' onclick='" + t + "' />";
				sReturn += "&nbsp;&nbsp;<img style='cursor:hand;' src='../images/move_up.gif' onclick='" + u + "' />";
				sReturn += "&nbsp;&nbsp;<img style='cursor:hand;' src='../images/move_down.gif' onclick='" + d + "' />";
				sReturn += "&nbsp;&nbsp;<img style='cursor:hand;' src='../images/move_bottom.png' onclick='" + b + "' />";
				break;
			case "last":
				sReturn += "<img style='cursor:hand;' src='../images/move_top.png' onclick='" + t + "' />";
				sReturn += "&nbsp;&nbsp;<img style='cursor:hand;' src='../images/move_up.gif' onclick='" + u + "' />";
				break;
			case "one":
				break;
		}
		return sReturn;
	},
	
	/* ---- Replace comma in the name or description field ---- */
	ReplaceComma: function(s, forward){
		var v = "";
		if(forward){
			v = s.replace(/,/g, "&rpls");
		}else{
			v = s.replace(/&rpls/g, ",");
		}
		return v;
	},
	
	/* ---- Check all rules for 80 and 8022 port ---- */
	CheckAllRules: function(pri){
		var p80 = false;
		/* ---- 2010.10.12  ---- */
		//var p8022 = false;
		var p8080 = false;
		for(var i = 0; i < this.oSettings.rules.length; i++){
			var r = this.oSettings.rules[i];
			if(r.act == "ACCEPT" && r.pri != pri && r.protocol != "UDP"){
				var a = r.port.split(":");
				var sp = parseInt(a[0]);
				var ep = parseInt(a[1]);
				if(sp <= this.oSettings.sshport && this.oSettings.sshport <= ep){
					p80 = true;
				}
				/* ---- 2010.10.12 ---- */
				//if(sp <= this.oSettings.httpport && this.oSettings.httpport <= ep){
				//	p8022 = true;
				//}
				if(sp <= this.oSettings.cgiport && this.oSettings.cgiport <= ep){
					p8080 = true;
				}
			}
		}
		/* ---- 2010.10.12 ---- */
		//if(p80 && p8022 && p8080){
		//	return true;
		//}
		if(p80 && p8080){
			return true;
		}
		return false;
	},
	
	/* ---- Check all defence for not repeating ---- */
	CheckAllDefence: function(port, protocol){
		for(var i = 0; i < this.oSettings.defence.length; i++){
			var d = this.oSettings.defence[i];
			if(d.port==port && d.protocol==protocol){
				return true;
			}
		}
		return false;
	},
	
	CheckRuleValid: function(){
		if (!ASTGUI.checkRequiredFields(["rulename", "ruleportstart", "ruleportend"])) {
			return false;
		}
		if (!ASTGUI.validateFields(["rulename", "ruledescription", "ruleportstart", "ruleportend", "rulemac", "ruleip", "rulemask"])){
			return false;
		}
		var name = _$("rulename").value;
		if(name.length > 50){
			ASTGUI.highlightField("rulename", SG_FIREWALL_RULENAMELIMIT);
			return false;
		}
		
		if( /[\\\"\'&,;]/.test(name) ) {
			ASTGUI.highlightField("rulename", voiptrunk_special);
			return;
		}
		var des = _$("ruledescription").value;
		if(des.length > 200){
			ASTGUI.highlightField("ruledescription", SG_FIREWALL_RULEDESCRIPLIMIT);
			return false;
		}
		if( /[\\\"\',;&*]/.test(des) ) {
			ASTGUI.highlightField("ruledescription", voiptrunk_special);
			return;
		}
		var sport = _$("ruleportstart").value;
		sport = sport.trim();sport = parseInt(sport);
		var eport = _$("ruleportend").value;
		eport = eport.trim();eport = parseInt(eport);
		if(sport<=0 || sport>65535){
			ASTGUI.highlightField("ruleportstart", SG_FIREWALL_PORTINVALID);
			return false;
		}
		if(eport<=0 || eport>65535){
			ASTGUI.highlightField("ruleportend", SG_FIREWALL_PORTINVALID);
			return false;
		}
		if(eport < sport){
			ASTGUI.highlightField("ruleportend", SG_FIREWALL_PORTGREATER);
			return false;
		}
		var ip = _$("ruleip").value; ip = ip.trim();
		if(ip!="" && !is_ipaddress(ip)){
			ASTGUI.highlightField("ruleip", networking_Invalid_IP);
			return false;
		}
		var mask = _$("rulemask").value; mask = mask.trim();
		if(mask!="" && !is_ipaddress(mask)){
			ASTGUI.highlightField("rulemask", networking_Invalid_IP);
			return false;
		}
		
		if(mask!="" && ip==""){
			ASTGUI.highlightField("ruleip", SG_FIREWALL_IPBLANK);
			return false;
		}
		
		var mac = _$("rulemac").value;
		mac = mac.trim();
		if(mac!="" && !IsValidMac(mac)){
			ASTGUI.highlightField("rulemac", SG_FIREWALL_INVALIDMAC);
			return false;
		}
		
		/* ---- Check rule for port 80 and 8022 ---- */
		var act = _$("ruleaction").value;
		var pro = _$("ruleprotocol").value;
		if(act!="ACCEPT" && pro!="UDP"){
			if( (sport<=this.oSettings.sshport && this.oSettings.sshport<=eport) 
			|| (sport<=this.oSettings.httpport && this.oSettings.httpport<=eport) 
			|| (sport<=this.oSettings.cgiport && this.oSettings.cgiport<=eport)){
				var s = SG_FIREWALL_LIMITPORT;
				s = s.replace("%p1", this.oSettings.sshport);
				s = s.replace("%p2", this.oSettings.httpport);
				s = s.replace("%p3", this.oSettings.cgiport);
				alert(s);
				return false;
			}
		}		
		
		return true;
	},
	
	CheckDefenceValid: function(){
		if (!ASTGUI.checkRequiredFields(["defenceport", "defencecount"])) {
			return false;
		}
		if (!ASTGUI.validateFields(["defenceport", "defencecount"])){
			return false;
		}
		var port = _$("defenceport").value;
		port = parseInt(port);
		if(port<=0 || port>65535){
			ASTGUI.highlightField("defenceport", SG_FIREWALL_PORTINVALID);
			return false;
		}
		var t = _$("defencecount").value;
		if(parseInt(t) <= 0){
			ASTGUI.highlightField("defencecount", SG_FIREWALL_RATECOUNTZERO);
			return false;
		}
		return true;
	},
	
	CheckSipDefenceValid: function(){
		if (!ASTGUI.checkRequiredFields(["sipdefencecount", "sipdefenceinterval"])) {
			return false;
		}
		if (!ASTGUI.validateFields(["sipdefencecount", "sipdefenceinterval"])){
			return false;
		}
		var t = _$("sipdefencecount").value;
		t = parseInt(t);
		if(t<=0 || t>120){
			ASTGUI.highlightField("sipdefencecount", SG_FIREWALL_RATELIMIT);
			return false;
		}
		t = _$("sipdefenceinterval").value;
		if(parseInt(t) <= 0){
			ASTGUI.highlightField("sipdefenceinterval", SG_FIREWALL_SIPINTERVALLIMIT);
			return false;
		}
		return true;
	},
	
	GlobalChanged: function(sId){
		if(sId == "dropunmatch"){
			/*---- If there is no rule contains the 80 and 8022 with the action 'ACCEPT', check the drop unmatch checkbox is not alowed ----*/
			if(this.CheckAllRules() == false){
				var s = SG_FIREWALL_LIMITDROPUNMATCH;
				s = s.replace("%p1", this.oSettings.sshport);
				s = s.replace("%p2", this.oSettings.httpport);
				s = s.replace("%p3", this.oSettings.cgiport);
				alert(s);
				_$(sId).checked = false;
				return;
			}
		}
	},
	
	SubmitGlobal: function(){		
		var oForm = document.forms[0];
		oForm.setAttribute("action", make_request_url_firewall(G_SERVER_URL, 2013));
		append_input(oForm, "enable", _$("enable").checked);
		append_input(oForm, "disableping", _$("disableping").checked);
		append_input(oForm, "dropunmatch", _$("dropunmatch").checked);
		oForm.submit();
	},
	
	ResetGlobal: function(){
		_$("enable").checked = this.oSettings.enable;
		_$("disableping").checked = this.oSettings.disableping;
		_$("dropunmatch").checked = this.oSettings.dropunmatch;
	},
	
	SubmitRule: function(){
		if(!this.CheckRuleValid()){
			return;
		}
		var oForm = document.forms[0];
		append_input(oForm, "name", this.ReplaceComma(_$("rulename").value, true));
		append_input(oForm, "des", this.ReplaceComma(_$("ruledescription").value, true));
		append_input(oForm, "protocol", _$("ruleprotocol").value);
		var s = _$("ruleportend").value;
		s = s.trim();
		if(s == ""){
			append_input(oForm, "port", _$("ruleportstart").value);
		}
		else{
			append_input(oForm, "port", _$("ruleportstart").value+":"+_$("ruleportend").value);
		}
		s = _$("rulemask").value;
		s = s.trim();
		if(s == ""){
			append_input(oForm, "ip", _$("ruleip").value);
		}else{
			append_input(oForm, "ip", _$("ruleip").value+"/"+_$("rulemask").value);
		}
		append_input(oForm, "mac", _$("rulemac").value);
		append_input(oForm, "act", _$("ruleaction").value);
		if(this.bRuleEdit){
			append_input(oForm, "pri", _$("rulepriority").value);
			oForm.setAttribute("action", make_request_url_firewall(G_SERVER_URL, 2003));
		}
		else{
			oForm.setAttribute("action", make_request_url_firewall(G_SERVER_URL, 2001));
		}		
		oForm.submit();
	},
	
	SubmitDefence: function(){
		if(!this.CheckDefenceValid()){
			return;
		}
		var oForm = document.forms[0];
		append_input(oForm, "port", _$("defenceport").value);
		append_input(oForm, "protocol", _$("defenceprotocol").value);
		append_input(oForm, "count", _$("defencecount").value);
		var s = _$("defenceinterval").value;
		var t = "1";
		if(s == "sec"){
			t = "1";
		}else if(s == "min"){
			t = "60";
		}else {
			t = "3600";
		}
		append_input(oForm, "interval", t);
		append_input(oForm, "type", "0");
		if(this.bDefenceEdit){
			append_input(oForm, "pri", _$("defencepriority").value);
			oForm.setAttribute("action", make_request_url_firewall(G_SERVER_URL, 2007));
		}
		else{
			oForm.setAttribute("action", make_request_url_firewall(G_SERVER_URL, 2005));
		}
		oForm.submit();
	},
	
	SubmitSipDefence: function(){
		if(!this.CheckSipDefenceValid()){
			return;
		}
		var oForm = document.forms[0];
		//append_input(oForm, "port", _$("sipdefenceport").value);
		append_input(oForm, "count", _$("sipdefencecount").value);
		append_input(oForm, "protocol", _$("sipdefenceprotocol").value);
		append_input(oForm, "interval", _$("sipdefenceinterval").value);
		append_input(oForm, "type", "1");
		if(this.bSipDefenceEdit){
			append_input(oForm, "pri", _$("sipdefencepriority").value);
			oForm.setAttribute("action", make_request_url_firewall(G_SERVER_URL, 2007));
		}
		else{
			oForm.setAttribute("action", make_request_url_firewall(G_SERVER_URL, 2005));
		}
		oForm.submit();
	},
	
	RestartFirewall: function(){
		window.location.href = make_request_url_firewall(G_SERVER_URL, 2014);
	},
	
	InitialPage: function(){
		var sValue = getMypbxString();
		var a;
		
		/* ---- Get firewall settings from input tag's value ---- */
		a = GetCommData(sValue, "&Global:", ";");
		if(a){
			a = a[0].split(",");
			this.oSettings.enable      = (a[0]=="1"?true:false);
			this.oSettings.disableping = (a[1]=="1"?true:false);
			this.oSettings.dropunmatch = (a[2]=="1"?true:false);
			this.oSettings.status      = parseInt(a[3]);			
			this.oSettings.sshport = parseInt(a[4]);
			this.oSettings.httpport = parseInt(a[5]);
			this.oSettings.cgiport = parseInt(a[6]);
			this.oSettings.sipport = parseInt(a[7]);
			
			_$("enable").checked = this.oSettings.enable;
			_$("disableping").checked = this.oSettings.disableping;
			_$("dropunmatch").checked = this.oSettings.dropunmatch;
			var o = _$("firewallstatus");
			if (this.oSettings.status == 0) {
				o.style.color = "#00FF00";
				o.style.display = "";
				o.innerHTML = SG_FIREWALL_SUCCEFUL;
			}
			else {
				if(this.oSettings.status == (0xfffffff-1)){
					o.style.color = "#0000FF";
					o.style.display = "";
					o.innerHTML = SG_FIREWALL_NOTSTART;
				}else{
					o.style.color = "#FF0000";
					o.style.display = "";
					o.innerHTML = SG_FIREWALL_FAILED;
				}
			}
		}
		
		/* ---- Get firewall rules from input tag's value ---- */
		a = GetCommData(sValue, "&Rules:", ";");
		if(a){
			for(var i = 0; i < a.length; i++){
			if(a[i] != ""){
				var r = a[i].split(",");
				this.oSettings.rules.push(new Rule(r[0], r[1], this.ReplaceComma(r[2],false), this.ReplaceComma(r[3],false), r[4], r[5], r[6], r[7]));
				}
			}
			this.oSettings.rules.sort(SortRule);
		}
		
		/* ---- If there is no rule contains the 80 and 8022 with the action 'ACCEPT', reset the drop unmatch checkbox to unchecked ---- */
		if(this.CheckAllRules()==false && this.oSettings.dropunmatch){
			_$("dropunmatch").checked = false;
			var oForm = document.forms[0];
			oForm.setAttribute("action", make_request_url_firewall(G_SERVER_URL, 2013));
			append_input(oForm, "enable", _$("enable").checked);
			append_input(oForm, "disableping", _$("disableping").checked);
			append_input(oForm, "dropunmatch", _$("dropunmatch").checked);
			append_input(oForm, "autodefence", true);
			append_input(oForm, "sipdefence", _$("sipdefence").checked);
			//append_input(oForm, "minrate", _$("minuterate").value);
			//append_input(oForm, "secrate", _$("secondrate").value);
			oForm.submit();
			return;
		}
		
		/* ---- Get firewall auto defences rules from input tag's value ---- */
		a = GetCommData(sValue, "&Defence:", ";");
		if(a){
			for(var i = 0; i < a.length; i++){
			if(a[i] != ""){
					var d = a[i].split(",");
					this.oSettings.defence.push(new Defence(d[0], d[1], d[2], d[3], d[4], d[5]));
				}
			}
		}
		
		var addCell = ASTGUI.domActions.tr_addCell;
		var oTable = _$("rules");
		InsertTableHeader(oTable, this.aRuleHeader);
		
		/* ---- Insert firewall rules into table ---- */
		var l = this.oSettings.rules.length;
			for(var i = 0; i < l; i++) {
			var arrow = "";
			var r = this.oSettings.rules[i];
			if(l == 1){
				arrow = this.AddArrow("one", r.pri);
			}
			else{
				if(i == 0){
					arrow = this.AddArrow("first", r.pri);
				}else if(i == l-1){
					arrow = this.AddArrow("last", r.pri);
				}else{
					arrow = this.AddArrow("middle", r.pri);
				}
			}
			var newRow = oTable.insertRow(-1);
			newRow.className = ((oTable.rows.length)%2==1)?'odd':'even';
			addCell( newRow , { html: arrow } );
			addCell( newRow , { html: r.act || '--' } );
			addCell( newRow , { html: r.name || '--' } );
			addCell( newRow , { html: r.protocol || '--' } );
			addCell( newRow , { html: r.ip || '--' } );
			addCell( newRow , { html: r.mac || '--' } );
			addCell( newRow , { html: r.port || '--' } );
			addCell( newRow , { html: this.AddFirewallOption(2002, 2004, r.pri, SG_FIREWALL_RULEDEL, r.pri, true)} );
		}	
		if( oTable.rows.length == 1  ){
			ASTGUI.domActions.clear_table(oTable);
			var newRow = oTable.insertRow(-1);
			addCell( newRow , { html: "<br><b>" + SG_FIREWALL_RULENONE + "</b><br><br>" } );
		}
		
		oTable = _$("defence");
		InsertTableHeader(oTable, this.aDefenceHeader);
		
		/* ---- Insert auto defence rules into table ---- */
		l = this.oSettings.defence.length;
		for(var i = 0; i < l; i++) {
			var d = this.oSettings.defence[i];
			if(d.type != "0"){
				continue;
			}
			var newRow = oTable.insertRow(-1);
			newRow.className = ((oTable.rows.length)%2==1)?'odd':'even';
			addCell( newRow , { html: d.port || '--' } );
			addCell( newRow , { html: d.protocol || '--' } );
			addCell( newRow , { html: d.count+"/"+this.MakeDefenceInterval(d.interval) || '--' } );
			addCell( newRow , { html: this.AddFirewallOption(2006, 2008, d.pri, SG_FIREWALL_DEFENCEDEL, d.pri, false)} );
		}	
		if( oTable.rows.length == 1  ){
			ASTGUI.domActions.clear_table(oTable);
			var newRow = oTable.insertRow(-1);
			addCell( newRow , { html: "<br><b>" + SG_FIREWALL_DEFENCENONE + "</b><br><br>" } );
		}
		
		oTable = _$("sipdefence");
		InsertTableHeader(oTable, this.aSipDefenceHeader);
		
		/* ---- Insert sip defence rules into table ---- */
		l = this.oSettings.defence.length;
		for(var i = 0; i < l; i++) {
			var d = this.oSettings.defence[i];
			if(d.type != "1"){
				continue;
			}
			var newRow = oTable.insertRow(-1);
			newRow.className = ((oTable.rows.length)%2==1)?'odd':'even';
			addCell( newRow , { html: d.count || '--' } );
			addCell( newRow , { html: d.interval || '--' } );
			addCell( newRow , { html: this.AddFirewallOption(2006, 2008, d.pri, SG_FIREWALL_SIPDEFENCEDEL, d.pri, false)} );
		}
		if( oTable.rows.length == 1  ){
			ASTGUI.domActions.clear_table(oTable);
			var newRow = oTable.insertRow(-1);
			addCell( newRow , { html: "<br><b>" + SG_FIREWALL_SIPDEFENCENONE + "</b><br><br>" } );
		}
	},
	InitialNewRule: function(){
		$('ruleeditor').showWithBg();
		var oDiv = _$("ruleeditor");
		oDiv.style.display = "";
		this.bRuleEdit = false;
		_$("ruleeditortitle").innerHTML = SG_FIREWALL_RULENEW;
		_$("rulename").value = "";
		_$("ruledescription").value = "";
		_$("ruleprotocol").value = "TCP";
		_$("ruleportstart").value = "";
		_$("ruleportend").value = "";
		_$("ruleip").value = "";
		_$("rulemask").value = "";
		_$("rulemac").value = "";
		_$("ruleaction").value = "DROP";
	},
	InitialNewDefence: function(){
		$('defenceeditor').showWithBg();
		var oDiv = _$("defenceeditor");
		oDiv.style.display = "";
		this.bDefenceEdit = false;
		_$("defenceeditortitle").innerHTML = SG_FIREWALL_DEFENCENEW;
		_$("defenceport").disabled = false;
		_$("defenceprotocol").disabled = false;
		_$("defenceport").value = "";
		_$("defenceprotocol").value = "TCP";
		_$("defencecount").value = "";
		_$("defenceinterval").value = "sec";
	},
	InitialNewSipDefence: function(){
		$('sipdefenceeditor').showWithBg();
		var oDiv = _$("sipdefenceeditor");
		oDiv.style.display = "";
		this.bSipDefenceEdit = false;
		_$("sipdefenceeditortitle").innerHTML = SG_FIREWALL_SIPDEFENCENEW;
		_$("sipdefenceport").disabled = true;
		_$("sipdefenceport").value = this.oSettings.sipport;
		_$("sipdefencecount").value = "";
		_$("sipdefenceinterval").value = "";
	},
	InitialEditRule: function(){
		$('ruleeditor').showWithBg();
		var oDiv = _$("ruleeditor");
		oDiv.style.display = "";
		this.bRuleEdit = true;
		_$("ruleeditortitle").innerHTML = SG_FIREWALL_RULEEDIT;
		var sValue = getMypbxString();
		var a = GetCommData_SpecialEnd(sValue, "&EditRule:", ";");
		if(a){
			a = a[0].split(",");
			var r = new Rule(a[0], a[1], a[2], a[3], a[4], a[5], a[6], a[7]);
			_$("rulename").value = this.ReplaceComma(r.name,false);
			_$("ruledescription").value = this.ReplaceComma(r.des,false);
			_$("ruleprotocol").value = r.protocol;a = r.port.split(":");
			_$("ruleportstart").value = a[0];
			_$("ruleportend").value = (a[1])?a[1]:"";
			a = r.ip.split("/");
			_$("ruleip").value = a[0];
			_$("rulemask").value = (a[1])?a[1]:"";
			_$("rulemac").value = r.mac;
			_$("ruleaction").value = r.act;
			_$("rulepriority").value = r.pri;
		}
	},
	InitialEditDefence: function(){
		var sValue = getMypbxString();
		var a = GetCommData(sValue, "&EditDefence:", ";");
		if(a){
			a = a[0].split(",");
			var d = new Defence(a[0], a[1], a[2], a[3], a[4], a[5]);
			if(d.type == 0){
				$('defenceeditor').showWithBg();
				var oDiv = _$("defenceeditor");
				oDiv.style.display = "";
				this.bDefenceEdit = true;
				_$("defenceeditortitle").innerHTML = SG_FIREWALL_DEFENCEEDIT;
				_$("defencepriority").value = d.pri;
				_$("defenceport").value = d.port;
				_$("defenceprotocol").value = d.protocol.toUpperCase();
				_$("defencecount").value = d.count;
				_$("defenceinterval").value = this.MakeDefenceInterval(d.interval);
			}else{
				$('sipdefenceeditor').showWithBg();
				var oDiv = _$("sipdefenceeditor");
				oDiv.style.display = "";
				this.bSipDefenceEdit = true;
				_$("sipdefenceeditortitle").innerHTML = SG_FIREWALL_SIPDEFENCEEDIT;
				_$("sipdefenceport").disabled = true;
				_$("sipdefenceport").value = this.oSettings.sipport;
				_$("sipdefenceprotocol").value = d.protocol.toUpperCase();
				_$("sipdefencecount").value = d.count;
				_$("sipdefenceinterval").value = d.interval;
				_$("sipdefencepriority").value = d.pri;
			}
		}
	}
}